<id>
Contact Page for YaBB 2.6.11
</id>

<version>
0.7
</version>

<mod info>
Description
-----------
Adds a Contact Page to your Forum.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload ContactPageSettings.pm to Admin/Mods, ContactPage.lng to Language/English/Mods, ContactPage.pm to Sources/Mods, and ContactPage.template to Templates/default/Mods. You may need to create the Mod folders for these.
4) Upload contact.gif to yabbfiles/ModImages.

NOTE: To remove this mod using BoardMod, the edit Variables/Settings.pm section of this mod must be removed. Variables/Settings.pm must be edited by hand to remove "contact" from @AdvancedTabs list. 

Files to edit
-------------
AdminIndex.pl
Admin/AdminSublist.pm
Admin/ModList.pm
Languages/English/Admin.lng
Languages/English/Email.lng
Languages/English/Menu.lng
Sources/AdvancedTabs.pm
Sources/SubList.pm
Sources/Subs.pm
Sources/TabMenu.pm
Templates/default/Menu.def
Variables/Settings.pm

Version History
---------------
V0.1 - First release - 16th January 2010
V0.2 - Added Spam Detection - 20th January 2010
V0.3 - Updated for YaBB 2.5 - 15th July 2010
V0.4 - Updated for 2.6.0 by Dandello - 11th July, 2014
V0.5 - Updated for 2.6.1 by Dandello - 2nd Sept, 2014
V0.6 - Updated for 2.6.1 Build 1606 by Dandello - 16th Nov, 2014
V0.7 - Updated for 2.6.11 by Dandello - 13th Jan, 2015
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$contactpage_mod = "contactpage|$mod_list{'contact'}|$mod_list{'contact1'}|";
push @boardmod_mods, $contactpage_mod;
</add before>

<edit file>
Admin/AdminSublist.pm
</edit file>

<search for>
1;
</search for>

<add before>
### Contact Page Mod Start ###
$director{'contactpage'} = 'Mods/ContactPageSettings.pm&ContactPage';
$director{'contactpage2'} = 'Mods/ContactPageSettings.pm&ContactPage2';
### Contact Page Mod End ###
</add before>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $contactpage_mod = qq~Contact Page|Derek Barnstorm, updated for 2.6.11 by Dandello|Adds a Contact Page to your Forum. [<span class="small"><a href="$adminurl?action=contactpage" style="font-weight: bold;">Contact Page Settings</a></span>]|0.7|23 Jan 2015~;
    push @installed_mods, $contactpage_mod;
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
### Contact Page Mod Start ###
$mod_list{'contact'} = 'Contact Page Settings';
$mod_list{'contact1'} = 'Edit Contact Page Settings';

### Contact Page Mod End ###

</add before>

<edit file>
Languages/English/Email.lng
</edit file>

<search for>
1;
</search for>

<add before>
### Contact Page Mod Start ###
$contactform = qq~<pre>Subject: {yabb contactsubject}
Name: {yabb yourname}
Email: {yabb youremail}
IP Address: {yabb contactip}
Message:
{yabb contactmessage}</pre>~;

$contactform_selfcopy = qq~<pre>Subject: {yabb contactsubject}
Name: {yabb yourname}
Email: {yabb youremail}
Message:
{yabb contactmessage}</pre>~;

$contactform_autorespond = qq~{yabb autoresponse}~;
### Contact Page Mod End ###

</add before>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>

require Sources::Menu;
</search for>

<add before>
$img_txt{'contact'} = 'Contact'; ### Contact Page Mod ###

</add before>

<edit file>
Sources/AdvancedTabs.pm
</edit file>

<search for>
## Mod hook tablist ##
</search for>

<add after>
 push @tablist, 'contact'; ### Contact Page Mod ###
</add after>

<search for>
## End Mod Hook GetTextTab ##
</search for>

<add before>
    $texttab{'contact'}           = $img_txt{'contact'}; ### Contact Page Mod ###
</add before>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
### Contact Page Mod Start ###
$director{'contact'} = 'Mods/ContactPage.pm&Contact';
$director{'contactsend'} = 'Mods/ContactPage.pm&ContactSend';
### Contact Page Mod End ###

</add before>

<edit file>
Sources/TabMenu.pm
</edit file>

<search for>
    $yytabmenu = qq~<ul>\n~;
</search for>

<add before>
    ### Contact Page Mod Start ###
    if (-e "$vardir/ContactPage.txt") { require "$vardir/ContactPage.txt"; }
    if ($en_contactpage == 2 || (!$iamguest && $en_contactpage == 1)) {
        $tab{'contact'} = qq~$tabhtml_l"$scripturl?action=contact" title="$img_txt{'contact'}">$tabfill$img_txt{'contact'}$tabfill</a>$tabhtml_r~;
    }
    ### Contact Page Mod End ###
</add before>

<edit file>
Templates/default/Menu.def
</edit file>

<search for>
collapse,collapse|img_txt|623|||imgwindowbg|png|tmp
</search for>

<add after>
contact,contact|img_txt|contact|||imgwindowbg|png|tmp
</add after>

<edit file>
Variables/Settings.pm
</edit file>

<search for>
1;
</search for>

<add before>
push @AdvancedTabs, 'contact';

</add before>
