###############################################################################
# ContactPageSettings.pm                                                      #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.11                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2015 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use CGI::Carp qw(fatalsToBrowser);
our $VERSION = '2.6.11';

$contactpagesettingspmver = 'YaBB 2.6.11 $Revision: 0.7 $';
if ( $action eq 'detailedversion' ) { return 1; }

if ( !-e ("$vardir/ContactPage.txt") ) { ContactPage2(); }
require "$vardir/ContactPage.txt";

LoadLanguage('Mods/ContactPage');
get_template('Mods/ContactPage');

sub ContactPage {

    is_admin_or_gmod();

    if    ( !$en_contactpage )     { $selcon1       = ' selected="selected"'; }
    elsif ( $en_contactpage == 1 ) { $selcon2       = ' selected="selected"'; }
    elsif ( $en_contactpage == 2 ) { $selcon3       = ' selected="selected"'; }
    if    ($en_conspellcheck)      { $chkspellcheck = ' checked="checked" '; }
    if    ( !$en_valimage )        { $selval1       = ' selected="selected"'; }
    elsif ( $en_valimage == 1 )    { $selval2       = ' selected="selected"'; }
    elsif ( $en_valimage == 2 )    { $selval3       = ' selected="selected"'; }
    if    ( !$en_valquest )        { $selvalq1      = ' selected="selected"'; }
    elsif ( $en_valquest == 1 )    { $selvalq2      = ' selected="selected"'; }
    elsif ( $en_valquest == 2 )    { $selvalq3      = ' selected="selected"'; }
    if    ($en_selfcopy)           { $chkselfcopy   = ' checked="checked" '; }
    if ($en_contact_auto) { $chkcontact_auto = ' checked="checked" '; }

    chomp $contact_subjects;
    $contact_subjects =~ s/\|/\n/gsm;
    $contact_auto =~ s/<br \/>/\n/gsm;

    if ( -e "$langdir/$language/spam.questions" ) {
        $contact_spam = $my_contact_admin_spam;
        $contact_spam =~ s/{yabb selvalq1}/$selvalq1/gsm;
        $contact_spam =~ s/{yabb selvalq2}/$selvalq2/gsm;
        $contact_spam =~ s/{yabb selvalq3}/$selvalq3/gsm;
    }
    if ( $enable_spell_check ) {
        $contact_splchk = $my_contact_admin_splchk;
        $contact_splchk =~ s/{yabb chkspellcheck}/$chkspellcheck/gsm;
    }

    $yymain = $contact_admin_main;
    $yymain =~ s/{yabb selcon1}/$selcon1/gsm;
    $yymain =~ s/{yabb selcon2}/$selcon2/gsm;
    $yymain =~ s/{yabb selcon3}/$selcon3/gsm;
    $yymain =~ s/{yabb contact_email}/$contact_email/gsm;
    $yymain =~ s/{yabb subject_pre}/$subject_pre/gsm;
    $yymain =~ s/{yabb contact_subjects}/$contact_subjects/gsm;
    $yymain =~ s/{yabb MaxConMesLen}/$MaxConMesLen/gsm;
    $yymain =~ s/{yabb chkspellcheck}/$chkspellcheck/gsm;
    $yymain =~ s/{yabb selval1}/$selval1/gsm;
    $yymain =~ s/{yabb selval2}/$selval2/gsm;
    $yymain =~ s/{yabb selval3}/$selval3/gsm;
    $yymain =~ s/{yabb contact_spam}/$contact_spam/gsm;
    $yymain =~ s/{yabb contact_splchk}/$contact_splchk/gsm;
    $yymain =~ s/{yabb chkselfcopy}/$chkselfcopy/gsm;
    $yymain =~ s/{yabb selfcopy_email}/$selfcopy_email/gsm;
    $yymain =~ s/{yabb selfcopy_name}/$selfcopy_name/gsm;
    $yymain =~ s/{yabb autores_sub}/$autores_sub/gsm;
    $yymain =~ s/{yabb chkcontact_auto}/$chkcontact_auto/gsm;
    $yymain =~ s/{yabb contact_auto}/$contact_auto/gsm;
    $yymain =~ s/{yabb autores_email}/$autores_email/gsm;
    $yymain =~ s/{yabb autores_name}/$autores_name/gsm;
    $yymain =~ s/{yabb autores_pre}/$autores_pre/gsm;

    $yytitle     = $mod_list{'contact1'};
    $action_area = 'contactpage';
    AdminTemplate();
    exit;
}

sub ContactPage2 {

    is_admin_or_gmod();

    $en_contactpage   = $FORM{'en_contactpage'} || 0;
    $contact_email    = $FORM{'contact_email'};
    $en_conspellcheck = $FORM{'en_conspellcheck'} || 0;
    $en_valimage      = $FORM{'en_valimage'} || 0;
    $en_valquest      = $FORM{'en_valquest'} || 0;
    $MaxConMesLen     = $FORM{'MaxConMesLen'} || 2000;
    $en_selfcopy      = $FORM{'en_selfcopy'} || 0;
    $selfcopy_email   = $FORM{'selfcopy_email'};
    $selfcopy_name    = $FORM{'selfcopy_name'};
    $selfcopy_pre     = $FORM{'selfcopy_pre'};
    $subject_pre      = $FORM{'subject_pre'};
    $contact_subjects = $FORM{'contact_subjects'};
    $en_contact_auto  = $FORM{'en_contact_auto'} || 0;
    $contact_auto     = $FORM{'contact_auto'};
    FromChars($contact_auto);
    ToHTML($contact_auto);
    $contact_auto =~ s/[\n\r]{1,2}/<br \/>/gsm;
    ToChars($contact_auto);
    $autores_email = $FORM{'autores_email'};
    $autores_name  = $FORM{'autores_name'};
    $autores_pre   = $FORM{'autores_pre'};
    chomp $contact_subjects;
    $contact_subjects =~ s/\r//gsm;
    $contact_subjects =~ s/\n/|/gsm;

    my $setfile = << "EOF";
###############################################################################
# ContactPage.txt (Contact Page configurations)                               #
###############################################################################

\$en_contactpage = $en_contactpage;
\$contact_email = "\Q$contact_email\E";
\$en_conspellcheck = $en_conspellcheck;
\$en_valimage = $en_valimage;
\$en_valquest = $en_valquest;
\$MaxConMesLen = $MaxConMesLen;
\$en_selfcopy = $en_selfcopy;
\$selfcopy_email = "\Q$selfcopy_email\E";
\$selfcopy_name = "\Q$selfcopy_name\E";
\$selfcopy_pre = "\Q$selfcopy_pre\E";
\$subject_pre = "\Q$subject_pre\E";
\$contact_subjects = "\Q$contact_subjects\E";
\$en_contact_auto = $en_contact_auto;
\$contact_auto = "$contact_auto";
\$autores_email = "\Q$autores_email\E";
\$autores_name = "\Q$autores_name\E";
\$autores_pre = "\Q$autores_pre\E";

1;
EOF

    fopen( FILE, ">$vardir/ContactPage.txt" );
    print {FILE} $setfile or croak "$croak{'print'} $setfile";
    fclose(FILE);

    if ( $action eq 'contactpage2' ) {
        $yySetLocation = qq~$adminurl?action=contactpage~;
        redirectexit();
    }
    return;
}

1;
